// globals

let table;

let url = "https://docs.google.com/spreadsheets/d/e/2PACX-1vRp2S059QkN1BrtbwHlUMkQo54v4AkRLkdB1O8OinGKRsw264uznOdKBlm8jrKkxIGXnt8H0XEGzl1g/pub?gid=107430643&single=true&output=csv"

// make title for bar chart
let title = 'Wine Prices Boxplot';

// variables

let price_list = [];

let min_price = 0;
let max_price = 0;
let median = 0;

let firstq = 0;
let thirdq = 0;

// set up variables to scale plot
// set up scale
let y_start = 100;

let y_length = 400;

let y_end = y_start + y_length;

let x_start = 120;

let x_length = 400

let x_end = x_start + x_length;

// variable for tick marks value
let j=0;

function preload() {
    table = loadTable(url,'csv','header');
}


function setup() {
    createCanvas(600, 600);

    var price = table.getColumn('price');

    console.log(price);

  rows = table.getRowCount();

  for (var i = 0; i < price.length; i++) {
    price_list.push(price[i]);
  }

  // print(price_list.length);

  price_list = price_list.sort((a, b) => a - b);


  price_list = price_list.map(Number);

  // print(price);


  median = Math.floor(price_list[((price_list.length-1)/2)]);

  // print("Median is: " + median);

  min_price = price_list[0];
  max_price = price_list[rows-1];

  // print("index of median: " + (price_list.length-1)/2)

  med_index = (price_list.length-1) / 2;

  // print('min price: ' + min_price);
  // print('max price: ' + max_price);

  lower = price_list.slice(0, med_index-1);
  upper = price_list.slice(med_index+1, price_list.length-1);

  // print("length of lower list: " + lower.length);
  // print("length of upper list: " + upper.length);

  first_med_index = lower.length / 2;
  third_med_index = upper.length / 2;

  firstq = (lower[first_med_index] + lower[first_med_index+1]) / 2;
  thirdq = (upper[third_med_index] + upper[third_med_index+1]) / 2;

  // print("first quartile is: " + firstq);
  // print("third quartile is: " + thirdq);


  noLoop();


}

function draw() {

    background(217,255,245);

    // use variables, min_price, max_price, median, firstq, thirdq
    // to setup points for boxplot

  // x-axis
  line(x_start, y_end, x_end, y_end);

  // y-axis
  line(x_start, y_start, x_start,y_end);

  // make scale measurement
  let scale = y_length/3400;

  // make tick marks along y-axis
  stroke(0);
  textAlign(RIGHT, CENTER);
  for (i = y_end; i > y_start; i -= 100 * scale) {
    line(x_start-5 , i, x_start+5, i);

    if (j == 0) {
      text(j, x_start - 20, i);

    } else {
      text(j + '$', x_start - 20, i);

    }
    j+=100;
  }


  fill(0);
  // create ellipses and line for max
  ellipse(x_start + x_length/2 , y_end - (max_price * scale), 4);
  line((x_start + x_length/2 )-15, y_end - (max_price * scale), (x_start + x_length/2 )+15, y_end - (max_price * scale));

  // create ellipses and line for min
  ellipse(x_start + x_length/2 , y_end - (min_price * scale), 4);
  line((x_start + x_length/2 )-15, y_end - (min_price * scale), (x_start + x_length/2 )+15, y_end - (min_price * scale));

  fill(243,116,174);
  // create vertical rectangle for boxplot
  rect(x_start + x_length/2 - 15, y_end - (thirdq * scale), 30, (thirdq * scale) - (firstq * scale));

  fill(0);
  // create line connecting max to 3rd quartile
  line(x_start + x_length/2, y_end - (max_price * scale), x_start + x_length/2, y_end - (thirdq * scale));

  // create line connecting min to 1st quartile
  line(x_start + x_length/2, y_end - (min_price * scale), x_start + x_length/2, y_end - (firstq * scale));

  // create line for median
  line(x_start + x_length/2 -15, y_end - (median*scale), x_start + x_length/2 +15, y_end - (median*scale));

  textSize(16);
  textAlign(CENTER)
  // place title
  text(title, x_start + x_length/2, 50);

  // x-axis labeled
  text('Dataset', x_start + x_length/2, y_end + 30);

  textSize(14);
  // y-axis labeled
  text('Price', x_start - 85, 250);

}